#ifndef __CFAF320240F_035T_H__
#define __CFAF320240F_035T_H__
//============================================================================
//
// Display definitions for:
//   CFA10086 with FT810
//
// Display:
//   CFAF320240F-035T-TS (Resistive Touch)
//   https://www.crystalfontz.com/product/cfaf320240f035tts
//   CFAF320240F-035T (Non-Touch)
//   https://www.crystalfontz.com/product/cfaf320240f035t
// Controller:
//   https://www.crystalfontz.com/controllers/Solomon%20Systech/SSD2119
//
// 2019-07-08 Crystalfontz America, Inc. / Brent A. Crosby
//===========================================================================
//This is free and unencumbered software released into the public domain.
//
//Anyone is free to copy, modify, publish, use, compile, sell, or
//distribute this software, either in source code form or as a compiled
//binary, for any purpose, commercial or non-commercial, and by any
//means.
//
//In jurisdictions that recognize copyright laws, the author or authors
//of this software dedicate any and all copyright interest in the
//software to the public domain. We make this dedication for the benefit
//of the public at large and to the detriment of our heirs and
//successors. We intend this dedication to be an overt act of
//relinquishment in perpetuity of all present and future rights to this
//software under copyright law.
//
//THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
//EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
//MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
//IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR
//OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
//ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
//OTHER DEALINGS IN THE SOFTWARE.
//
//For more information, please refer to <http://unlicense.org/>

//============================================================================
//Determined by the 10086 hardware and controller
#define LCD_SWIZZLE   (2)  // Define RGB output pins (PCB layout)
#define LCD_PCLKPOL   (0)  // Define active edge of PCLK (0=pos, 1=neg)
#define LCD_PCLK      (8)  // Pixel Clock 7.5MHz @ FTDI Clock of 60Hz
// Frame_Rate = 7.5M / (LCD_VCYCLE*LCD_HCYCLE) = 66.5Hz or 15mS
//----------------------------------------------------------------------------
// Horizontal timing, maximizes horizontal line cycles while maintaining
// 60hz frame rate.
#define HPX   (320)  // Horizontal Pixel Width
#define HSW   (10)   // Horizontal Sync Width
#define HBP   (20)   // Horizontal Back Porch
#define HFP   (10)   // Horizontal Front Porch
#define HPP   (150)  // Horizontal Pixel Padding (empirical)

// Define the constants needed by the FT8xx based on the timing
// Active width of LCD display
#define LCD_WIDTH   (HPX)
// Start of horizontal sync pulse
#define LCD_HSYNC0  (HFP)
// End of horizontal sync pulse
#define LCD_HSYNC1  (HFP+HSW)
// Start of active line
#define LCD_HOFFSET (HFP+HSW+HBP)
// Total number of clocks per line
#define LCD_HCYCLE  (HPX+HFP+HSW+HBP+HPP)
//----------------------------------------------------------------------------
// Vertical timing
#define VLH   (240) // Vertical Line Height
#define VS    (3)   // Vertical Sync (in lines)
#define VBP   (0)   // Vertical Back Porch
#define VFP   (1)   // Vertical Front Porch
#define VLP   (1)   // Vertical Line Padding (empirical)

// Define the constants needed by the FT8xx based on the timing
// Active height of LCD display
#define LCD_HEIGHT  (VLH)
// Start of vertical sync pulse
#define LCD_VSYNC0  (VFP)
// End of vertical sync pulse
#define LCD_VSYNC1  (VFP+VS)
// Start of active screen
#define LCD_VOFFSET (VFP+VS+VBP)
// Total number of lines per screen
#define LCD_VCYCLE  (VLH+VFP+VS+VBP+VLP)

#endif // __CFAF320240F_035T_H__
